var Stage = require("../models/stage.js");
var winston = require('winston');
var fs = require("fs");
var path = require("path");
var mkdirp = require('mkdirp');
var async = require('async');
var sherlockFile = path.join('.', 'sherlock.json');
var sherlockConfig={};
var config={};


winston.info("STARTING loadDefaultJobStage");

//###########################################
//###### Configuring Stage
//###########################################
var loadDefaultJobStage = new Stage("Load default jobs");
loadDefaultJobStage.applyWhen(function(answers){
	winston.insfo("SELECTED OPTION: "+ answers.mainOption);
	return answers.mainOption === "Run report";
});


if(sherlockFile && fs.existsSync(sherlockFile)){
	winston.info('Loading ' + sherlockFile);
	configContent = fs.readFileSync(sherlockFile);
	sherlockConfig = JSON.parse(configContent);
	winston.info('sherlock.json: ',  sherlockConfig);
}

jobs = [];
var choices=[];

if(sherlockConfig.jobsLocation){
	sherlockConfig.jobsLocation = path.resolve(sherlockConfig.jobsLocation);
	winston.info(sherlockConfig.jobsLocation);
}

if(sherlockConfig.jobsLocation && fs.existsSync(sherlockConfig.jobsLocation)){
	winston.info('Loading jobs from '+sherlockConfig.jobsLocation);
	var jobPath = path.join(sherlockConfig.jobsLocation);
	jobs = fs.readdirSync(jobPath);
	console.log(jobs.length + ' jobs was founded');

	for (var i = jobs.length - 1; i >= 0; i--) {
		var job = jobs[i];
		winston.info(job);
		choices.push(job);
	};
}else{
	winston.info('No jobs found in '+sherlockConfig.jobsLocation);
}

loadDefaultJobStage.addQuestion({
	type: "list",
	name: "selectedJob",
	message: "Select one job to run",
	choices: choices.sort()
});
//###########################################
//###### Configuring Stage
//###########################################
loadDefaultJobStage.after(function(answers, callback){
	var job = path.join(__dirname, '..','jobs', answers.selectedJob);
	try{
		var instance = require(job);
	}catch(err){
		console.log(err);
	}
	callback();
});

module.exports = loadDefaultJobStage;