var Stage = require("../models/stage.js");
var winston = require('winston');
var fs = require("fs");
var path = require("path");
var mkdirp = require('mkdirp');
var async = require('async');
var sherlockFile = path.join('.', 'sherlock.json');

//###########################################
//###### Configuring Stage
//###########################################
var loadDefaultJobStage = new Stage("Load main jobs");
loadDefaultJobStage.applyWhen(function(answers){
	return true;
});

loadDefaultJobStage.addQuestion({
	type: "list",
	name: "mainOption",
	message: "Select one option to run",
	choices: ['Run report','Reset password']
});

loadDefaultJobStage.after(function(answers, callback){
	var userHome = getUserHome();
	var usernameConfig=path.join(userHome, '.sherlock', 'auth');
	if(answers.mainOption == 'Reset password' && fs.existsSync(usernameConfig)){
		fs.unlink(usernameConfig, function (err) {
		  if (err) throw err;
		  console.log('   \033[removed\033[0m : ' + usernameConfig);
		  callback();
		});
	}else{
		callback();
	}
});

function getUserHome() {
  return process.env[(process.platform == 'win32') ? 'USERPROFILE' : 'HOME'];
}

module.exports = loadDefaultJobStage;